@echo off
setlocal EnableDelayedExpansion

if exist "%PROGRAMFILES(X86)%" (
	set CHOICE=choice64.exe
	set CHOICE_TEXT_PARAM=/m
) else (
	if "%PROCESSOR_ARCHITECTURE%" == "x86" (
		set CHOICE=choice32.exe
		set CHOICE_TEXT_PARAM=
	) else (
		set CHOICE=choice64.exe
		set CHOICE_TEXT_PARAM=/m
	)
)

echo ==============================================
echo =                                            =
echo =  [NUT]'s definitive Remount-Reboot fixer!  =
echo =           A.K.A. 'the rootfix'             =
echo =                                            =
echo ==============================================

cd files

set menu_currentIndex=1
set menu_choices=1

echo [ !menu_currentIndex!. SuperSU ]

set /a menu_currentIndex+=1 >nul
set menu_choices=!menu_choices!!menu_currentIndex!

echo [ !menu_currentIndex!. SuperUser ]

set /a menu_currentIndex+=1 >nul
set menu_choices=!menu_choices!!menu_currentIndex!

echo [ !menu_currentIndex!. Abort! ]

%CHOICE% /c:!menu_choices! %CHOICE_TEXT_PARAM% "Which root app do you use?"

set menu_decision=%errorlevel%
set menu_currentIndex=
set menu_choices=

if "!menu_decision!" == "3" (
	goto abort
)

adb kill-server
adb start-server

echo =============================================
echo Waiting for Device, connect USB cable now...
echo =============================================
adb wait-for-device
echo Device found!
echo.
echo =============================================
echo Sending the rootfix files.
echo =============================================
adb shell "mkdir /data/local/tmp/rootfix"
adb push killric.sh /data/local/tmp/rootfix/killric.sh
adb push ctrlaltdel /data/local/tmp/rootfix/ctrlaltdel
adb push install-recovery.sh /data/local/tmp/rootfix/install-recovery.sh
adb push busybox /data/local/tmp/rootfix/busybox
adb push install.sh /data/local/tmp/rootfix/install.sh

echo.
echo =============================================
echo Installing the rootfix.
echo NOTE: If your device reboots without prior
echo notification, the installation failed!
echo Please take a screenshot or copy & paste the
echo contents of this dosbox to the topic on XDA.
echo =============================================
adb shell "chmod 755 /data/local/tmp/rootfix/install.sh"
adb shell "chmod 755 /data/local/tmp/rootfix/busybox"

if "!menu_decision!" == "1" (
	echo Look at your device and grant supersu access!
	echo Press any key to continue AFTER granting root access.
	adb shell "su -c /system/bin/ls -la /data/local/tmp/rootfix/busybox"
	pause
)

adb shell "su -c /data/local/tmp/rootfix/install.sh"

ping -n 4 127.0.0.1 > NUL
echo Waiting for your device to reconnect.
adb wait-for-device

echo Remounting system to see if it worked OK
adb shell "su -c /system/xbin/busybox mount -o remount,rw /system"
echo Wait 40 seconds to see if it worked, then
pause

adb shell "rm -rf /data/local/tmp/rootfix"

adb kill-server

echo.
echo =============================================
echo Installation finished. Enjoy your trouble 
echo            free root experience!
echo =============================================
echo.

pause
goto end

:abort
echo.
echo =============================================
echo            Installation aborted!
echo =============================================
echo.

pause
goto end

:end
